import 'package:gherkin/gherkin.dart';
import 'package:gherkin_dsl/gherkin_dsl.dart';

import 'common.dart';

class GenericGiven<TWorld extends World> extends GivenWithWorld<TWorld>{
  String _pattern;
  Zero<TWorld> _step;


  GenericGiven(this._pattern, this._step);

  @override
  Future<void> executeStep() async {
    await _step(this);
  }

  @override
  RegExp get pattern => RegExp(_pattern);
}
GenericGiven given<TWorld extends World>(String pattern,Zero<TWorld> step){
  return GenericGiven<TWorld>(pattern,step);
}
class GenericGiven1<TWorld extends World,Input1> extends Given1WithWorld<Input1,TWorld>{
  String _pattern;
  One<TWorld,Input1> _step;


  GenericGiven1(this._pattern, this._step);

  @override
  Future<void> executeStep(Input1 first) async {
    await _step(this,first);
  }

  @override
  RegExp get pattern => RegExp(_pattern);
}
GenericGiven1 given1<TWorld extends World,Input1>(String pattern,One<TWorld,Input1> step){
  return GenericGiven1<TWorld,Input1>(pattern,step);
}

