import 'package:gherkin/gherkin.dart';
import 'package:gherkin_dsl/gherkin_dsl.dart';

import 'common.dart';

class GenericThen<TWorld extends World> extends ThenWithWorld<TWorld>{
  String _pattern;
  Zero<TWorld> _step;


  GenericThen(this._pattern, this._step);

  @override
  Future<void> executeStep() async {
    await _step(this);
  }

  @override
  RegExp get pattern => RegExp(_pattern);
}
GenericThen then<TWorld extends World>(String pattern,Zero<TWorld> step){
  return GenericThen<TWorld>(pattern,step);
}

class GenericThen1<TWorld extends World,Input1> extends Then1WithWorld<Input1,TWorld>{
  String _pattern;
  One<TWorld,Input1> _step;


  GenericThen1(this._pattern, this._step);

  @override
  Future<void> executeStep(Input1 first) async {
    await _step(this,first);
  }

  @override
  RegExp get pattern => RegExp(_pattern);
}
GenericThen1 then1<TWorld extends World,Input1>(String pattern,One<TWorld,Input1> step){
  return GenericThen1<TWorld,Input1>(pattern,step);
}
class GenericThen2<TWorld extends World,Input1,Input2> extends Then2WithWorld<Input1,Input2,TWorld>{
  String _pattern;
  Two<TWorld,Input1,Input2> _step;


  GenericThen2(this._pattern, this._step);

  @override
  Future<void> executeStep(Input1 first,Input2 second) async {
    await _step(this,first,second);
  }

  @override
  RegExp get pattern => RegExp(_pattern);
}
GenericThen2 then2<TWorld extends World,Input1,Input2>(String pattern,Two<TWorld,Input1,Input2> step){
  return GenericThen2<TWorld,Input1,Input2>(pattern,step);
}

